// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from scenario_execution_interfaces:msg/Scenario.idl
// generated code does not contain a copyright notice
#include "scenario_execution_interfaces/msg/detail/scenario__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `name`
// Member `scenario_file`
#include "rosidl_runtime_c/string_functions.h"

bool
scenario_execution_interfaces__msg__Scenario__init(scenario_execution_interfaces__msg__Scenario * msg)
{
  if (!msg) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__init(&msg->name)) {
    scenario_execution_interfaces__msg__Scenario__fini(msg);
    return false;
  }
  // scenario_file
  if (!rosidl_runtime_c__String__init(&msg->scenario_file)) {
    scenario_execution_interfaces__msg__Scenario__fini(msg);
    return false;
  }
  return true;
}

void
scenario_execution_interfaces__msg__Scenario__fini(scenario_execution_interfaces__msg__Scenario * msg)
{
  if (!msg) {
    return;
  }
  // name
  rosidl_runtime_c__String__fini(&msg->name);
  // scenario_file
  rosidl_runtime_c__String__fini(&msg->scenario_file);
}

bool
scenario_execution_interfaces__msg__Scenario__are_equal(const scenario_execution_interfaces__msg__Scenario * lhs, const scenario_execution_interfaces__msg__Scenario * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // scenario_file
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->scenario_file), &(rhs->scenario_file)))
  {
    return false;
  }
  return true;
}

bool
scenario_execution_interfaces__msg__Scenario__copy(
  const scenario_execution_interfaces__msg__Scenario * input,
  scenario_execution_interfaces__msg__Scenario * output)
{
  if (!input || !output) {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // scenario_file
  if (!rosidl_runtime_c__String__copy(
      &(input->scenario_file), &(output->scenario_file)))
  {
    return false;
  }
  return true;
}

scenario_execution_interfaces__msg__Scenario *
scenario_execution_interfaces__msg__Scenario__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  scenario_execution_interfaces__msg__Scenario * msg = (scenario_execution_interfaces__msg__Scenario *)allocator.allocate(sizeof(scenario_execution_interfaces__msg__Scenario), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(scenario_execution_interfaces__msg__Scenario));
  bool success = scenario_execution_interfaces__msg__Scenario__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
scenario_execution_interfaces__msg__Scenario__destroy(scenario_execution_interfaces__msg__Scenario * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    scenario_execution_interfaces__msg__Scenario__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
scenario_execution_interfaces__msg__Scenario__Sequence__init(scenario_execution_interfaces__msg__Scenario__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  scenario_execution_interfaces__msg__Scenario * data = NULL;

  if (size) {
    data = (scenario_execution_interfaces__msg__Scenario *)allocator.zero_allocate(size, sizeof(scenario_execution_interfaces__msg__Scenario), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = scenario_execution_interfaces__msg__Scenario__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        scenario_execution_interfaces__msg__Scenario__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
scenario_execution_interfaces__msg__Scenario__Sequence__fini(scenario_execution_interfaces__msg__Scenario__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      scenario_execution_interfaces__msg__Scenario__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

scenario_execution_interfaces__msg__Scenario__Sequence *
scenario_execution_interfaces__msg__Scenario__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  scenario_execution_interfaces__msg__Scenario__Sequence * array = (scenario_execution_interfaces__msg__Scenario__Sequence *)allocator.allocate(sizeof(scenario_execution_interfaces__msg__Scenario__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = scenario_execution_interfaces__msg__Scenario__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
scenario_execution_interfaces__msg__Scenario__Sequence__destroy(scenario_execution_interfaces__msg__Scenario__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    scenario_execution_interfaces__msg__Scenario__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
scenario_execution_interfaces__msg__Scenario__Sequence__are_equal(const scenario_execution_interfaces__msg__Scenario__Sequence * lhs, const scenario_execution_interfaces__msg__Scenario__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!scenario_execution_interfaces__msg__Scenario__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
scenario_execution_interfaces__msg__Scenario__Sequence__copy(
  const scenario_execution_interfaces__msg__Scenario__Sequence * input,
  scenario_execution_interfaces__msg__Scenario__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(scenario_execution_interfaces__msg__Scenario);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    scenario_execution_interfaces__msg__Scenario * data =
      (scenario_execution_interfaces__msg__Scenario *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!scenario_execution_interfaces__msg__Scenario__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          scenario_execution_interfaces__msg__Scenario__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!scenario_execution_interfaces__msg__Scenario__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
