// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from scenario_execution_interfaces:msg/Scenario.idl
// generated code does not contain a copyright notice

#ifndef SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO__TRAITS_HPP_
#define SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "scenario_execution_interfaces/msg/detail/scenario__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace scenario_execution_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const Scenario & msg,
  std::ostream & out)
{
  out << "{";
  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: scenario_file
  {
    out << "scenario_file: ";
    rosidl_generator_traits::value_to_yaml(msg.scenario_file, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Scenario & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: scenario_file
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scenario_file: ";
    rosidl_generator_traits::value_to_yaml(msg.scenario_file, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Scenario & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace scenario_execution_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use scenario_execution_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const scenario_execution_interfaces::msg::Scenario & msg,
  std::ostream & out, size_t indentation = 0)
{
  scenario_execution_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use scenario_execution_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const scenario_execution_interfaces::msg::Scenario & msg)
{
  return scenario_execution_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<scenario_execution_interfaces::msg::Scenario>()
{
  return "scenario_execution_interfaces::msg::Scenario";
}

template<>
inline const char * name<scenario_execution_interfaces::msg::Scenario>()
{
  return "scenario_execution_interfaces/msg/Scenario";
}

template<>
struct has_fixed_size<scenario_execution_interfaces::msg::Scenario>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<scenario_execution_interfaces::msg::Scenario>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<scenario_execution_interfaces::msg::Scenario>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO__TRAITS_HPP_
