// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from scenario_execution_interfaces:msg/ScenarioStatus.idl
// generated code does not contain a copyright notice

#ifndef SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_STATUS__STRUCT_HPP_
#define SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'system_time'
// Member 'ros_time'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__scenario_execution_interfaces__msg__ScenarioStatus __attribute__((deprecated))
#else
# define DEPRECATED__scenario_execution_interfaces__msg__ScenarioStatus __declspec(deprecated)
#endif

namespace scenario_execution_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ScenarioStatus_
{
  using Type = ScenarioStatus_<ContainerAllocator>;

  explicit ScenarioStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : system_time(_init),
    ros_time(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data = "";
    }
  }

  explicit ScenarioStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : system_time(_alloc, _init),
    ros_time(_alloc, _init),
    data(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->data = "";
    }
  }

  // field types and members
  using _system_time_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _system_time_type system_time;
  using _ros_time_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _ros_time_type ros_time;
  using _data_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _data_type data;

  // setters for named parameter idiom
  Type & set__system_time(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->system_time = _arg;
    return *this;
  }
  Type & set__ros_time(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->ros_time = _arg;
    return *this;
  }
  Type & set__data(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->data = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__scenario_execution_interfaces__msg__ScenarioStatus
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__scenario_execution_interfaces__msg__ScenarioStatus
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ScenarioStatus_ & other) const
  {
    if (this->system_time != other.system_time) {
      return false;
    }
    if (this->ros_time != other.ros_time) {
      return false;
    }
    if (this->data != other.data) {
      return false;
    }
    return true;
  }
  bool operator!=(const ScenarioStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ScenarioStatus_

// alias to use template instance with default allocator
using ScenarioStatus =
  scenario_execution_interfaces::msg::ScenarioStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace scenario_execution_interfaces

#endif  // SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_STATUS__STRUCT_HPP_
