// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from scenario_execution_interfaces:srv/ExecuteScenario.idl
// generated code does not contain a copyright notice

#ifndef SCENARIO_EXECUTION_INTERFACES__SRV__DETAIL__EXECUTE_SCENARIO__TRAITS_HPP_
#define SCENARIO_EXECUTION_INTERFACES__SRV__DETAIL__EXECUTE_SCENARIO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "scenario_execution_interfaces/srv/detail/execute_scenario__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'scenario'
#include "scenario_execution_interfaces/msg/detail/scenario__traits.hpp"

namespace scenario_execution_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const ExecuteScenario_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: scenario
  {
    out << "scenario: ";
    to_flow_style_yaml(msg.scenario, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ExecuteScenario_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: scenario
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "scenario:\n";
    to_block_style_yaml(msg.scenario, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ExecuteScenario_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace scenario_execution_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use scenario_execution_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const scenario_execution_interfaces::srv::ExecuteScenario_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  scenario_execution_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use scenario_execution_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const scenario_execution_interfaces::srv::ExecuteScenario_Request & msg)
{
  return scenario_execution_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<scenario_execution_interfaces::srv::ExecuteScenario_Request>()
{
  return "scenario_execution_interfaces::srv::ExecuteScenario_Request";
}

template<>
inline const char * name<scenario_execution_interfaces::srv::ExecuteScenario_Request>()
{
  return "scenario_execution_interfaces/srv/ExecuteScenario_Request";
}

template<>
struct has_fixed_size<scenario_execution_interfaces::srv::ExecuteScenario_Request>
  : std::integral_constant<bool, has_fixed_size<scenario_execution_interfaces::msg::Scenario>::value> {};

template<>
struct has_bounded_size<scenario_execution_interfaces::srv::ExecuteScenario_Request>
  : std::integral_constant<bool, has_bounded_size<scenario_execution_interfaces::msg::Scenario>::value> {};

template<>
struct is_message<scenario_execution_interfaces::srv::ExecuteScenario_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace scenario_execution_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const ExecuteScenario_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: result
  {
    out << "result: ";
    rosidl_generator_traits::value_to_yaml(msg.result, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ExecuteScenario_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: result
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "result: ";
    rosidl_generator_traits::value_to_yaml(msg.result, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ExecuteScenario_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace scenario_execution_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use scenario_execution_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const scenario_execution_interfaces::srv::ExecuteScenario_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  scenario_execution_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use scenario_execution_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const scenario_execution_interfaces::srv::ExecuteScenario_Response & msg)
{
  return scenario_execution_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<scenario_execution_interfaces::srv::ExecuteScenario_Response>()
{
  return "scenario_execution_interfaces::srv::ExecuteScenario_Response";
}

template<>
inline const char * name<scenario_execution_interfaces::srv::ExecuteScenario_Response>()
{
  return "scenario_execution_interfaces/srv/ExecuteScenario_Response";
}

template<>
struct has_fixed_size<scenario_execution_interfaces::srv::ExecuteScenario_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<scenario_execution_interfaces::srv::ExecuteScenario_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<scenario_execution_interfaces::srv::ExecuteScenario_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<scenario_execution_interfaces::srv::ExecuteScenario>()
{
  return "scenario_execution_interfaces::srv::ExecuteScenario";
}

template<>
inline const char * name<scenario_execution_interfaces::srv::ExecuteScenario>()
{
  return "scenario_execution_interfaces/srv/ExecuteScenario";
}

template<>
struct has_fixed_size<scenario_execution_interfaces::srv::ExecuteScenario>
  : std::integral_constant<
    bool,
    has_fixed_size<scenario_execution_interfaces::srv::ExecuteScenario_Request>::value &&
    has_fixed_size<scenario_execution_interfaces::srv::ExecuteScenario_Response>::value
  >
{
};

template<>
struct has_bounded_size<scenario_execution_interfaces::srv::ExecuteScenario>
  : std::integral_constant<
    bool,
    has_bounded_size<scenario_execution_interfaces::srv::ExecuteScenario_Request>::value &&
    has_bounded_size<scenario_execution_interfaces::srv::ExecuteScenario_Response>::value
  >
{
};

template<>
struct is_service<scenario_execution_interfaces::srv::ExecuteScenario>
  : std::true_type
{
};

template<>
struct is_service_request<scenario_execution_interfaces::srv::ExecuteScenario_Request>
  : std::true_type
{
};

template<>
struct is_service_response<scenario_execution_interfaces::srv::ExecuteScenario_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // SCENARIO_EXECUTION_INTERFACES__SRV__DETAIL__EXECUTE_SCENARIO__TRAITS_HPP_
