// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from scenario_execution_interfaces:msg/Scenario.idl
// generated code does not contain a copyright notice

#ifndef SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO__STRUCT_HPP_
#define SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__scenario_execution_interfaces__msg__Scenario __attribute__((deprecated))
#else
# define DEPRECATED__scenario_execution_interfaces__msg__Scenario __declspec(deprecated)
#endif

namespace scenario_execution_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Scenario_
{
  using Type = Scenario_<ContainerAllocator>;

  explicit Scenario_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->scenario_file = "";
    }
  }

  explicit Scenario_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc),
    scenario_file(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->scenario_file = "";
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _scenario_file_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _scenario_file_type scenario_file;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__scenario_file(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->scenario_file = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    scenario_execution_interfaces::msg::Scenario_<ContainerAllocator> *;
  using ConstRawPtr =
    const scenario_execution_interfaces::msg::Scenario_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::msg::Scenario_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::msg::Scenario_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__scenario_execution_interfaces__msg__Scenario
    std::shared_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__scenario_execution_interfaces__msg__Scenario
    std::shared_ptr<scenario_execution_interfaces::msg::Scenario_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Scenario_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->scenario_file != other.scenario_file) {
      return false;
    }
    return true;
  }
  bool operator!=(const Scenario_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Scenario_

// alias to use template instance with default allocator
using Scenario =
  scenario_execution_interfaces::msg::Scenario_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace scenario_execution_interfaces

#endif  // SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO__STRUCT_HPP_
