// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from scenario_execution_interfaces:msg/ScenarioExecutionStatus.idl
// generated code does not contain a copyright notice

#ifndef SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_EXECUTION_STATUS__STRUCT_HPP_
#define SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_EXECUTION_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__scenario_execution_interfaces__msg__ScenarioExecutionStatus __attribute__((deprecated))
#else
# define DEPRECATED__scenario_execution_interfaces__msg__ScenarioExecutionStatus __declspec(deprecated)
#endif

namespace scenario_execution_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ScenarioExecutionStatus_
{
  using Type = ScenarioExecutionStatus_<ContainerAllocator>;

  explicit ScenarioExecutionStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit ScenarioExecutionStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    uint8_t;
  _status_type status;

  // setters for named parameter idiom
  Type & set__status(
    const uint8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t STOPPED =
    0u;
  static constexpr uint8_t STARTING =
    1u;
  static constexpr uint8_t RUNNING =
    2u;
  static constexpr uint8_t SHUTTINGDOWN =
    3u;
  // guard against 'ERROR' being predefined by MSVC by temporarily undefining it
#if defined(_WIN32)
#  if defined(ERROR)
#    pragma push_macro("ERROR")
#    undef ERROR
#  endif
#endif
  static constexpr uint8_t ERROR =
    4u;
#if defined(_WIN32)
#  pragma warning(suppress : 4602)
#  pragma pop_macro("ERROR")
#endif

  // pointer types
  using RawPtr =
    scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__scenario_execution_interfaces__msg__ScenarioExecutionStatus
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__scenario_execution_interfaces__msg__ScenarioExecutionStatus
    std::shared_ptr<scenario_execution_interfaces::msg::ScenarioExecutionStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ScenarioExecutionStatus_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    return true;
  }
  bool operator!=(const ScenarioExecutionStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ScenarioExecutionStatus_

// alias to use template instance with default allocator
using ScenarioExecutionStatus =
  scenario_execution_interfaces::msg::ScenarioExecutionStatus_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ScenarioExecutionStatus_<ContainerAllocator>::STOPPED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ScenarioExecutionStatus_<ContainerAllocator>::STARTING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ScenarioExecutionStatus_<ContainerAllocator>::RUNNING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ScenarioExecutionStatus_<ContainerAllocator>::SHUTTINGDOWN;
#endif  // __cplusplus < 201703L
// guard against 'ERROR' being predefined by MSVC by temporarily undefining it
#if defined(_WIN32)
#  if defined(ERROR)
#    pragma push_macro("ERROR")
#    undef ERROR
#  endif
#endif
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t ScenarioExecutionStatus_<ContainerAllocator>::ERROR;
#endif  // __cplusplus < 201703L
#if defined(_WIN32)
#  pragma warning(suppress : 4602)
#  pragma pop_macro("ERROR")
#endif

}  // namespace msg

}  // namespace scenario_execution_interfaces

#endif  // SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_EXECUTION_STATUS__STRUCT_HPP_
