// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from scenario_execution_interfaces:msg/ScenarioList.idl
// generated code does not contain a copyright notice

#ifndef SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_LIST__TRAITS_HPP_
#define SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_LIST__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "scenario_execution_interfaces/msg/detail/scenario_list__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'scenarios'
#include "scenario_execution_interfaces/msg/detail/scenario__traits.hpp"

namespace scenario_execution_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const ScenarioList & msg,
  std::ostream & out)
{
  out << "{";
  // member: scenarios
  {
    if (msg.scenarios.size() == 0) {
      out << "scenarios: []";
    } else {
      out << "scenarios: [";
      size_t pending_items = msg.scenarios.size();
      for (auto item : msg.scenarios) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ScenarioList & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: scenarios
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.scenarios.size() == 0) {
      out << "scenarios: []\n";
    } else {
      out << "scenarios:\n";
      for (auto item : msg.scenarios) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ScenarioList & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace scenario_execution_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use scenario_execution_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const scenario_execution_interfaces::msg::ScenarioList & msg,
  std::ostream & out, size_t indentation = 0)
{
  scenario_execution_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use scenario_execution_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const scenario_execution_interfaces::msg::ScenarioList & msg)
{
  return scenario_execution_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<scenario_execution_interfaces::msg::ScenarioList>()
{
  return "scenario_execution_interfaces::msg::ScenarioList";
}

template<>
inline const char * name<scenario_execution_interfaces::msg::ScenarioList>()
{
  return "scenario_execution_interfaces/msg/ScenarioList";
}

template<>
struct has_fixed_size<scenario_execution_interfaces::msg::ScenarioList>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<scenario_execution_interfaces::msg::ScenarioList>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<scenario_execution_interfaces::msg::ScenarioList>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_LIST__TRAITS_HPP_
