// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from scenario_execution_interfaces:msg/ScenarioList.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "scenario_execution_interfaces/msg/detail/scenario_list__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace scenario_execution_interfaces
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void ScenarioList_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) scenario_execution_interfaces::msg::ScenarioList(_init);
}

void ScenarioList_fini_function(void * message_memory)
{
  auto typed_message = static_cast<scenario_execution_interfaces::msg::ScenarioList *>(message_memory);
  typed_message->~ScenarioList();
}

size_t size_function__ScenarioList__scenarios(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<scenario_execution_interfaces::msg::Scenario> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ScenarioList__scenarios(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<scenario_execution_interfaces::msg::Scenario> *>(untyped_member);
  return &member[index];
}

void * get_function__ScenarioList__scenarios(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<scenario_execution_interfaces::msg::Scenario> *>(untyped_member);
  return &member[index];
}

void fetch_function__ScenarioList__scenarios(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const scenario_execution_interfaces::msg::Scenario *>(
    get_const_function__ScenarioList__scenarios(untyped_member, index));
  auto & value = *reinterpret_cast<scenario_execution_interfaces::msg::Scenario *>(untyped_value);
  value = item;
}

void assign_function__ScenarioList__scenarios(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<scenario_execution_interfaces::msg::Scenario *>(
    get_function__ScenarioList__scenarios(untyped_member, index));
  const auto & value = *reinterpret_cast<const scenario_execution_interfaces::msg::Scenario *>(untyped_value);
  item = value;
}

void resize_function__ScenarioList__scenarios(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<scenario_execution_interfaces::msg::Scenario> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ScenarioList_message_member_array[1] = {
  {
    "scenarios",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<scenario_execution_interfaces::msg::Scenario>(),  // members of sub message
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(scenario_execution_interfaces::msg::ScenarioList, scenarios),  // bytes offset in struct
    nullptr,  // default value
    size_function__ScenarioList__scenarios,  // size() function pointer
    get_const_function__ScenarioList__scenarios,  // get_const(index) function pointer
    get_function__ScenarioList__scenarios,  // get(index) function pointer
    fetch_function__ScenarioList__scenarios,  // fetch(index, &value) function pointer
    assign_function__ScenarioList__scenarios,  // assign(index, value) function pointer
    resize_function__ScenarioList__scenarios  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ScenarioList_message_members = {
  "scenario_execution_interfaces::msg",  // message namespace
  "ScenarioList",  // message name
  1,  // number of fields
  sizeof(scenario_execution_interfaces::msg::ScenarioList),
  ScenarioList_message_member_array,  // message members
  ScenarioList_init_function,  // function to initialize message memory (memory has to be allocated)
  ScenarioList_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ScenarioList_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ScenarioList_message_members,
  get_message_typesupport_handle_function,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace scenario_execution_interfaces


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<scenario_execution_interfaces::msg::ScenarioList>()
{
  return &::scenario_execution_interfaces::msg::rosidl_typesupport_introspection_cpp::ScenarioList_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, scenario_execution_interfaces, msg, ScenarioList)() {
  return &::scenario_execution_interfaces::msg::rosidl_typesupport_introspection_cpp::ScenarioList_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
