// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from scenario_execution_interfaces:msg/ScenarioStatus.idl
// generated code does not contain a copyright notice
#include "scenario_execution_interfaces/msg/detail/scenario_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `system_time`
// Member `ros_time`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `data`
#include "rosidl_runtime_c/string_functions.h"

bool
scenario_execution_interfaces__msg__ScenarioStatus__init(scenario_execution_interfaces__msg__ScenarioStatus * msg)
{
  if (!msg) {
    return false;
  }
  // system_time
  if (!builtin_interfaces__msg__Time__init(&msg->system_time)) {
    scenario_execution_interfaces__msg__ScenarioStatus__fini(msg);
    return false;
  }
  // ros_time
  if (!builtin_interfaces__msg__Time__init(&msg->ros_time)) {
    scenario_execution_interfaces__msg__ScenarioStatus__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__init(&msg->data)) {
    scenario_execution_interfaces__msg__ScenarioStatus__fini(msg);
    return false;
  }
  return true;
}

void
scenario_execution_interfaces__msg__ScenarioStatus__fini(scenario_execution_interfaces__msg__ScenarioStatus * msg)
{
  if (!msg) {
    return;
  }
  // system_time
  builtin_interfaces__msg__Time__fini(&msg->system_time);
  // ros_time
  builtin_interfaces__msg__Time__fini(&msg->ros_time);
  // data
  rosidl_runtime_c__String__fini(&msg->data);
}

bool
scenario_execution_interfaces__msg__ScenarioStatus__are_equal(const scenario_execution_interfaces__msg__ScenarioStatus * lhs, const scenario_execution_interfaces__msg__ScenarioStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // system_time
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->system_time), &(rhs->system_time)))
  {
    return false;
  }
  // ros_time
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->ros_time), &(rhs->ros_time)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->data), &(rhs->data)))
  {
    return false;
  }
  return true;
}

bool
scenario_execution_interfaces__msg__ScenarioStatus__copy(
  const scenario_execution_interfaces__msg__ScenarioStatus * input,
  scenario_execution_interfaces__msg__ScenarioStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // system_time
  if (!builtin_interfaces__msg__Time__copy(
      &(input->system_time), &(output->system_time)))
  {
    return false;
  }
  // ros_time
  if (!builtin_interfaces__msg__Time__copy(
      &(input->ros_time), &(output->ros_time)))
  {
    return false;
  }
  // data
  if (!rosidl_runtime_c__String__copy(
      &(input->data), &(output->data)))
  {
    return false;
  }
  return true;
}

scenario_execution_interfaces__msg__ScenarioStatus *
scenario_execution_interfaces__msg__ScenarioStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  scenario_execution_interfaces__msg__ScenarioStatus * msg = (scenario_execution_interfaces__msg__ScenarioStatus *)allocator.allocate(sizeof(scenario_execution_interfaces__msg__ScenarioStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(scenario_execution_interfaces__msg__ScenarioStatus));
  bool success = scenario_execution_interfaces__msg__ScenarioStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
scenario_execution_interfaces__msg__ScenarioStatus__destroy(scenario_execution_interfaces__msg__ScenarioStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    scenario_execution_interfaces__msg__ScenarioStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
scenario_execution_interfaces__msg__ScenarioStatus__Sequence__init(scenario_execution_interfaces__msg__ScenarioStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  scenario_execution_interfaces__msg__ScenarioStatus * data = NULL;

  if (size) {
    data = (scenario_execution_interfaces__msg__ScenarioStatus *)allocator.zero_allocate(size, sizeof(scenario_execution_interfaces__msg__ScenarioStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = scenario_execution_interfaces__msg__ScenarioStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        scenario_execution_interfaces__msg__ScenarioStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
scenario_execution_interfaces__msg__ScenarioStatus__Sequence__fini(scenario_execution_interfaces__msg__ScenarioStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      scenario_execution_interfaces__msg__ScenarioStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

scenario_execution_interfaces__msg__ScenarioStatus__Sequence *
scenario_execution_interfaces__msg__ScenarioStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  scenario_execution_interfaces__msg__ScenarioStatus__Sequence * array = (scenario_execution_interfaces__msg__ScenarioStatus__Sequence *)allocator.allocate(sizeof(scenario_execution_interfaces__msg__ScenarioStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = scenario_execution_interfaces__msg__ScenarioStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
scenario_execution_interfaces__msg__ScenarioStatus__Sequence__destroy(scenario_execution_interfaces__msg__ScenarioStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    scenario_execution_interfaces__msg__ScenarioStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
scenario_execution_interfaces__msg__ScenarioStatus__Sequence__are_equal(const scenario_execution_interfaces__msg__ScenarioStatus__Sequence * lhs, const scenario_execution_interfaces__msg__ScenarioStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!scenario_execution_interfaces__msg__ScenarioStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
scenario_execution_interfaces__msg__ScenarioStatus__Sequence__copy(
  const scenario_execution_interfaces__msg__ScenarioStatus__Sequence * input,
  scenario_execution_interfaces__msg__ScenarioStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(scenario_execution_interfaces__msg__ScenarioStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    scenario_execution_interfaces__msg__ScenarioStatus * data =
      (scenario_execution_interfaces__msg__ScenarioStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!scenario_execution_interfaces__msg__ScenarioStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          scenario_execution_interfaces__msg__ScenarioStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!scenario_execution_interfaces__msg__ScenarioStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
