// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from scenario_execution_interfaces:msg/ScenarioStatus.idl
// generated code does not contain a copyright notice

#ifndef SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_STATUS__TRAITS_HPP_
#define SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "scenario_execution_interfaces/msg/detail/scenario_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'system_time'
// Member 'ros_time'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace scenario_execution_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const ScenarioStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: system_time
  {
    out << "system_time: ";
    to_flow_style_yaml(msg.system_time, out);
    out << ", ";
  }

  // member: ros_time
  {
    out << "ros_time: ";
    to_flow_style_yaml(msg.ros_time, out);
    out << ", ";
  }

  // member: data
  {
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ScenarioStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: system_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "system_time:\n";
    to_block_style_yaml(msg.system_time, out, indentation + 2);
  }

  // member: ros_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ros_time:\n";
    to_block_style_yaml(msg.ros_time, out, indentation + 2);
  }

  // member: data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "data: ";
    rosidl_generator_traits::value_to_yaml(msg.data, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ScenarioStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace scenario_execution_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use scenario_execution_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const scenario_execution_interfaces::msg::ScenarioStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  scenario_execution_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use scenario_execution_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const scenario_execution_interfaces::msg::ScenarioStatus & msg)
{
  return scenario_execution_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<scenario_execution_interfaces::msg::ScenarioStatus>()
{
  return "scenario_execution_interfaces::msg::ScenarioStatus";
}

template<>
inline const char * name<scenario_execution_interfaces::msg::ScenarioStatus>()
{
  return "scenario_execution_interfaces/msg/ScenarioStatus";
}

template<>
struct has_fixed_size<scenario_execution_interfaces::msg::ScenarioStatus>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<scenario_execution_interfaces::msg::ScenarioStatus>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<scenario_execution_interfaces::msg::ScenarioStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SCENARIO_EXECUTION_INTERFACES__MSG__DETAIL__SCENARIO_STATUS__TRAITS_HPP_
